<template>
  <div class="block-filters">
    <button
      class="close"
      @click="$emit('close')">Close</button>

    <div class="ui form">
      <div
        v-if="fields.partManufacturer"
        class="field">
        <AppSelect
          :value="value.partManufacturer"
          :options="list.partManufacturer"
          :disabled="!list.partManufacturer.length"
          class="no-checkbox"
          track-by="id"
          label="name"
          id="partManufacturer"
          placeholder="Производитель"
          @select="change"
          @clear="clear('partManufacturer')"/>
      </div>

      <div
        v-if="fields.partName"
        class="field no_name-number-part">
        <AppSelect
          :value="value.partName"
          :options="list.partName"
          :disabled="!list.partName.length"
          class="no-checkbox"
          track-by="id"
          label="name"
          id="partName"
          placeholder="Название запчасти"
          @select="change"
          @clear="clear('partName')"/>
      </div>

      <div
        v-if="fields.partId"
        class="field no_name-number-part">
        <AppSelect
          :value="value.partId"
          :options="list.partId"
          :disabled="!list.partId.length"
          class="no-checkbox"
          track-by="id"
          label="name"
          id="partId"
          placeholder="Номер запчасти"
          @select="change"
          @clear="clear('partId')"/>
      </div>

      <div
        v-if="fields.carManufacturer"
        class="field">
        <AppSelect
          :value="value.carManufacturer"
          :options="list.carManufacturer"
          :disabled="!list.carManufacturer.length"
          class="no-checkbox"
          track-by="id"
          label="name"
          id="carManufacturer"
          placeholder="Марка авто"
          @select="change"
          @clear="clear('carManufacturer')"/>
      </div>

      <div class="field block-btn">
        <AppButton @click.native="$emit('apply')">
          <span
            slot="button-item"
            class="button-item">
            Показать
          </span>
        </AppButton>
      </div>
    </div>
  </div>
</template>

<script>
import AppSelect from '~/components/redesign/app-select/app-select';
import AppButton from '~/components/redesign/app-buttons/app-button';

export default {
  name: 'PpkFilters',
  components: {
    AppSelect,
    AppButton,
  },
  props: {
    list: {
      type: Object,
      default() { return {}; },
      required: true,
    },
    value: {
      type: Object,
      default() { return {}; },
      required: true,
    },
    fields: {
      type: Object,
      default() { return {}; },
    },
  },
  methods: {
    change(value = null, filter) {
      this.$emit('input', { ...this.value, [filter]: value });
    },
    clear(filter) {
      this.change(null, filter);
    },
  },
};
</script>

<style lang="postcss">
  .block-filters {
    position: relative;
    .close {
      display: none;
      font-size: 0;
      width: 2rem;
      height: 2rem;
      margin: 0 0 1rem auto;
      background-color: transparent;
      outline: none;
      border: none;
      cursor: pointer;
      background-size: 1rem;
      background-position: center;
      background-repeat: no-repeat;
      background-image: url("~assets/svg/icon-close-bold.svg");
    }
    @media screen and (max-width: 980px) {
      display: flex;
      flex-direction: column;
      flex-wrap: nowrap;
      width: 100vw;
      height: 100%;
      flex: 1 0 100%;
      padding: 1rem 1rem 0 1rem;
      background-color: #f4f4f4;
      border-top: 1px solid #C5D1D9;

      .close {
        display: block;
      }
    }
    @media screen and (min-width: 981px) {
      display: block;
      width: 100%;
      padding: 1.5rem 1rem;
      background-color: #ededed;
      box-shadow: 0 1px 2px rgba(0, 0, 0, 0.25);
    }
    .ui.form {
      display: flex;
      flex-direction: row;
      flex-wrap: nowrap;
      justify-content: flex-start;
      align-items: center;
      width: 100%;
      @media screen and (max-width: 980px) {
        flex-direction: column;
        height: auto;
      }
      .field {
        display: block;
        margin: 0;
        @media screen and (max-width: 980px) {
          width: 100%;
          + .field {
            margin-top: 1rem;
          }
        }
        @media screen and (min-width: 981px) {
          width: 12rem;
          min-width: 9.5rem;
          margin-right: 1rem;
          &.name-number-part {
            width: 17rem;
            min-width: 10.5rem;
          }
        }
      }

      .field.block-input {
        display: flex;
        flex-direction: row;
        flex-wrap: nowrap;
        justify-content: space-between;
        align-items: center;
        @media screen and (min-width: 981px) {
          width: 15rem;
          .ui.input {
            max-width: calc(50% - 2rem);
          }
        }

        @media screen and (max-width: 980px) {
          flex-wrap: wrap;
          label {
            width: 100%;
          }
          .ui.input {
            max-width: calc(50% - 0.4375rem);
          }
          .ui.input:nth-child(2) {
            position: relative;
            &:after {
              content: '';
              position: absolute;
              right: -0.875rem;
              top: 0;
              bottom: 0;
              width: 0.875rem;
              background-size: 0.375rem auto;
              background-repeat: no-repeat;
              background-position: center;
              background-image: url('data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHZpZXdCb3g9IjAgMCA0Ljk5NCAxMCI+DQogIDxkZWZzPg0KICAgIDxzdHlsZT4NCiAgICAgIC5jbHMtMSB7DQogICAgICAgIGZpbGw6ICM2YTdiODc7DQogICAgICB9DQogICAgPC9zdHlsZT4NCiAgPC9kZWZzPg0KICA8cGF0aCBpZD0iUGF0aF8xNjM2IiBkYXRhLW5hbWU9IlBhdGggMTYzNiIgY2xhc3M9ImNscy0xIiBkPSJNMCwwSDEwTDQuOTc5LDQuOTk0WiIgdHJhbnNmb3JtPSJ0cmFuc2xhdGUoLTAuMDAxIDEwKSByb3RhdGUoLTkwKSIvPg0KPC9zdmc+DQo=');
            }
          }
        }
      }

      .field.block-btn {
        display: flex;
        flex-direction: row;
        flex-wrap: nowrap;
        justify-content: space-between;
        align-items: center;
        width: auto;
        margin: 0;
        .ui.button.transparent {
          margin: 0 1rem;
        }
        .ui.button.yellow {
          width: 9.5rem;
        }
        /*@media (min-width: 1024px) and (max-width: 1199px) {
          .ui.button.yellow {
            width: auto;
          }
        }*/
        @media screen and (max-width: 980px) {
          width: 100%;
          margin: auto 0 0 0;
          padding-top: 2rem;
          flex-direction: column-reverse;
          .ui.button.transparent {
            margin: 1rem;
          }
          & > .button {
            width: 100%;
          }
        }
      }
    }
  }
</style>
